import sys
import os
#import time

class imw_object:  
    def __init__(self, objId, startTime):  
        self.objId = objId  
        self.startTime = startTime
        self.deltaTime = {}
        self.deltaTime2 = {}
        self.start_time_s = 0
        self.start_time_ns = 0
        
hookTime = 0
hookName = ""
hookParameter1 = ""
hookParameter2 = ""
time_s = 0
time_ns = 0
last_time_s = 0
last_time_ns = 0

outfolder="./"

addrA=""
addrB=""
addrC=""
addresses=["","","","",""]

imw_object_tx_list = {}
imw_object_rx_list = {}

globalTime = 0
deltaTime = 0

filename=sys.argv[1]
basename=os.path.splitext(filename)[0]
print(filename)

txRequired=int(sys.argv[2])
rxRequired=int(sys.argv[3])
txFragments=int(sys.argv[4])
rxFragments=int(sys.argv[5])

lastActivation=0
lineNr=0

def calc_delay_ns(start_s, start_ns, end_s, end_ns):
	if(start_s == end_s):
		return end_ns - start_ns
	else:
		return (end_s - start_s)*1000000000 + end_ns - start_ns

def handleHook():
	global hookTime, hookName, hookParameter1, hookParameter2, imw_object_tx_list, imw_object_rx_list, lastActivation, time_s, time_ns, lineNr
	if(hookName == "00000004"):
		imw_object_tx_list[hookParameter2] = imw_object(hookParameter2,hookTime)
		imw_object_tx_list[hookParameter2].start_time_s = time_s
		imw_object_tx_list[hookParameter2].start_time_ns = time_ns
	if(hookName == "0000000A"):
		try:
			obj = imw_object_tx_list[hookParameter1]
			obj.deltaTime[hookParameter2] = hookTime - obj.startTime
			obj.deltaTime2[hookParameter2] = calc_delay_ns(obj.start_time_s, obj.start_time_ns, time_s, time_ns)
		except:
			pass

			
	if(hookName == "00000005"):
		imw_object_rx_list[hookParameter1] = imw_object(hookParameter1,hookTime)
		imw_object_rx_list[hookParameter1].start_time_s = time_s
		imw_object_rx_list[hookParameter1].start_time_ns = time_ns
	if(hookName == "00000007"):
		try:
			obj = imw_object_rx_list[hookParameter1]
			obj.deltaTime[hookParameter2] = hookTime - obj.startTime
			obj.deltaTime2[hookParameter2] = calc_delay_ns(obj.start_time_s, obj.start_time_ns, time_s, time_ns)
		except:
			pass		
				

lastAddr=""
def parseLine(addr, value, deltaTime, globalTime):
	global hookTime, hookName, hookParameter1, hookParameter2, addresses, lastAddr
	if(addr == addresses[0]):
		hookTime = globalTime
		hookName = value
		lastAddr = addr
	elif(addr == addresses[1] and hookName != 0xFFFFFFFF and lastAddr == addresses[0]):
		hookParameter1 = int(value,16)
		lastAddr = addr
	elif(addr == addresses[2] and hookParameter1 != 0xFFFFFFFF and lastAddr == addresses[1]):
		hookParameter2 = int(value,16)
		handleHook()
		hookName = 0xFFFFFFFF
		hookParameter1 = 0xFFFFFFFF
		hookParameter2 = 0xFFFFFFFF



with open(filename) as f:
	lineNr = 1
	for line in f:
		if(line.startswith("-")):
			lis = line.split()
			if(len(lis) >= 3 and (lis[1].startswith("D:") or lis[1].startswith("A:"))):
				if(lineNr <= 5):
					addresses[lineNr-1] = lis[1]
				
				if(lineNr > 1):
					deltaTime = int('{:.9f}'.format(float(lis[3])).replace('.', ''));
					globalTime = globalTime + deltaTime
				parseLine(lis[1],lis[2], deltaTime, globalTime)
				lineNr = lineNr +1
			
	txObjMissing =0
	rxObjMissing =0
	f = open(outfolder+basename+"_rx.csv", 'w')
	for identifier in range(rxRequired):
		string=""
		try:
			obj = imw_object_rx_list[identifier]
			string = str(obj.objId)
			rxFragmentMissing = 0
			for fragment in range(rxFragments):
				try:
					time = obj.deltaTime[fragment]
					string = string + ";" + str(time)
				except:
					rxFragmentMissing += 1
					string = string + ";"
			if rxFragmentMissing != 0:
				rxObjMissing += 1
		except:
			rxObjMissing += 1#rxFragments
			#print(str(obj.objId)+"  all")
		if(string != ""):
			f.write(string + "\n")	
	f.close()
	
	f = open(outfolder+basename+"_tx.csv", 'w')
	for identifier in range(txRequired):
		string = ""
		try:
			obj = imw_object_tx_list[identifier]
			string = str(obj.objId)
			txFragmentMissing = 0
			for fragment in range(txFragments):
				try:
					time = obj.deltaTime[fragment]
					string = string + ";" + str(time)
				except:
					txFragmentMissing += 1
					string = string + ";"
					print(str(identifier)+"   "+str(fragment))
				if txFragmentMissing != 0:
					txObjMissing += 1
		except:
			txObjMissing += 1#txFragments
			#print(str(identifier)+"   all")
		if(string != ""):
			f.write(string + "\n")
	f.close()
	
#	for objId in imw_object_rx_list:
#		columnCount = 0
#		obj = imw_object_rx_list[objId]
#		print(imw_object_rx_list[objId])
#		string = str(obj.objId)
#		for deltaTime in obj.deltaTime:
#			string = string + ";" + str(obj.deltaTime[deltaTime])
#			columnCount = columnCount + 1
#		if(columnCount < rxFragments):
#			rxObjMissing += 1
#			for i in range(rxFragments - columnCount - 1):
#				string = string + ";"
#		f.write(string + "\n")
#	f.close()
	
#	f = open(outfolder+basename+"_tx.csv", 'w')
#	columnCountMax = max(len(imw_object_tx_list[objId].deltaTime) for objId in imw_object_tx_list)
#	print(len(imw_object_tx_list))
#	rowCount = len(imw_object_tx_list)
#	for objId in imw_object_tx_list:
#		columnCount = 0
#		obj = imw_object_tx_list[objId]
#		string = str(obj.objId)
#		for deltaTime in obj.deltaTime:
#			string = string + ";" + str(obj.deltaTime[deltaTime])
#			columnCount = columnCount + 1
#		if(columnCount < columnCountMax):
#			txObjMissing +=1
#			for i in range(columnCountMax - columnCount - 1):
#				string = string + ";"
#		f.write(string + "\n")
#	f.close()
	
	f = open(outfolder+basename+"_tx_missing.csv", 'w')
	f.write(str(txObjMissing))
	print("TX Missing: " + str(txObjMissing))
	f.close()
	
	f = open(outfolder+basename+"_rx_missing.csv", 'w')
	f.write(str(rxObjMissing))
	print("RX Missing: " + str(rxObjMissing))
	f.close()
